/*
 * Copyright (C) 2022, KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef DESKTOPWATCHER_H
#define DESKTOPWATCHER_H
#include <QFileSystemWatcher>
#include "directory_changed_thread.h"


class DesktopWatcher : public QObject
{
    Q_OBJECT
public:
    DesktopWatcher();
    ~DesktopWatcher();

public:
Q_SIGNALS:
    /**
     * @brief Desktop file directory change signal
     */
    void directoryChangedSignal();
    void updateRecentList();

public Q_SLOTS:

    void directoryChangedSlot(const QString &path);
    void requestUpdateSlot();

private:
    QFileSystemWatcher *m_fileWatcher = nullptr; //Monitor desktop folder status
//    QFileSystemWatcher *m_recentFile=nullptr;
    DirectoryChangedThread *m_directoryChangedThread = nullptr;
};

#endif // DESKTOPWATCHER_H
