/*
 * Copyright (C) 2022, KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef PAGEMANAGER_H
#define PAGEMANAGER_H

#include <QObject>
#include "ukuimenuinterface.h"

class PageManager : public QObject
{
    Q_OBJECT
public:
    PageManager();
    ~PageManager();

    int getPageNum(const int &appNum);
    QVector<QStringList> sortAppInPage(const QVector<QString> &appVector);
    QVector<QStringList> getAppPageVector();
private:
    UkuiMenuInterface *m_ukuiMenuInterface = nullptr;
};

#endif // PAGEMANAGER_H
