#ifndef PUSHBUTTON_H
#define PUSHBUTTON_H

#include <QObject>
#include <QLabel>
#include <QPushButton>
#include <QStylePainter>
#include <QStyleOption>
#include <QHBoxLayout>
#include "utility.h"

class IconLabel : public QLabel
{
    Q_OBJECT
public:
    IconLabel(QWidget *parent = nullptr);
    void setIcon(const QPixmap &pixmap);
protected:
    void paintEvent(QPaintEvent *event) override;

private:
    QPixmap m_pixmap;
};

class PushButton : public QPushButton
{
    Q_OBJECT
public:
    explicit PushButton(QWidget *parent = nullptr);
    ~PushButton();

    void setLabel(QPixmap pixmap, int size);

protected:
    void paintEvent(QPaintEvent *e) override;

private:
    QHBoxLayout *m_btnLayout = nullptr;
    IconLabel *m_label = nullptr;

Q_SIGNALS:

};
#endif // PUSHBUTTON_H
