#include "textlabel.h"
#include <QDebug>

TextLabel::TextLabel(QWidget *parent) : QLabel(parent)
{

}

void TextLabel::checkState(bool isChecked)
{
    m_isChecked = isChecked;
}

void TextLabel::paintEvent(QPaintEvent *event)
{
    if (m_isChecked) {
        return QLabel::paintEvent(event);
    }

    QStylePainter painter(this);
    painter.setRenderHint(QPainter::Antialiasing);
    QStyleOptionFrame option;
    initStyleOption(&option);

    if (option.state & QStyle::State_HasFocus) {
        painter.save();
        QStyleOption opt;
        QColor color = opt.palette.color(QPalette::Highlight);
        painter.setPen(QPen(color, 2));
        painter.drawRoundedRect(option.rect.adjusted(1, 1, -1, -1), 6, 6);
        painter.restore();
    }
    QLabel::paintEvent(event);
}
