/*
 * Copyright (C) 2022, KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef RIGHTLISTVIEW_H
#define RIGHTLISTVIEW_H
#include <QListView>
#include <QSettings>
#include "rightclickmenu.h"
#include "ukuimenuinterface.h"
#include <QEvent>
#include <QScrollBar>
#include <QToolTip>
#include <QStandardItemModel>
#include "right_item_delegate.h"
#include "style.h"
#include "utility.h"
#include "klistview.h"

class RightListView : public KListView
{
    Q_OBJECT
public:
    RightListView(QWidget *parent);
    ~RightListView();

    void initWidget();
protected:

    void keyPressEvent(QKeyEvent *e);
    void dropEvent(QDropEvent *event);
    void enterEvent(QEvent *e);
    void paintEvent(QPaintEvent *e);
    void leaveEvent(QEvent *e);

private:
    RightClickMenu *menu = nullptr; //右键菜单
    QStringList data;
    QGSettings *gsetting;
    QPoint m_dropPos;
    QColor m_styleColor;

//    bool inCurView;

public Q_SLOTS:

//    void rightClickedSlot(const QPoint &pos);//右键菜单
    void selectFirstItem();
    void changeStyleColor(const QColor &color);
    void onClicked(QModelIndex index);

Q_SIGNALS:

    void sendSetslidebar(int value);
};

#endif // FULLLISTVIEW_H
