/*
 * Copyright (C) 2022, KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#include "menubox.h"
#include <QDebug>
#include <QMouseEvent>
#include <QEventLoop>
#include <QTimer>

MenuBox::MenuBox(QWidget *parent):
    QMenu(parent)
{
}

void MenuBox::mousePressEvent(QMouseEvent *event)
{
    if (!this->actionAt(event->pos())) {
        Q_EMIT sendMainWinActiveSignal(true);
    }

    qDebug() << "void MenuBox::mousePressEvent(QMouseEvent *event)";
    return QMenu::mousePressEvent(event);
}

void MenuBox::hideEvent(QHideEvent *e)
{
    Q_EMIT sendMainWinActiveSignal(true);
    return QMenu::hideEvent(e);
}

