/*
 * Copyright (C) 2022, KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef MAINVIEWWIDGET_H
#define MAINVIEWWIDGET_H

#include <QWidget>
#include <QSpacerItem>
#include <QLineEdit>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QToolButton>
#include <QDesktopWidget>
#include <QKeyEvent>
#include <QScrollBar>
#include <QFileSystemWatcher>
#include <QSettings>
#include <QPainterPath>
#include "ukuimenuinterface.h"
#include "searchappthread.h"
#include "directory_changed_thread.h"
#include "convert_winid_to_desktop.h"
#include "style.h"
#include "src/UtilityFunction/utility.h"
#include <QComboBox>
#include <QCheckBox>

class MainViewWidget : public QWidget
{
    Q_OBJECT

public:
    explicit MainViewWidget(QWidget *parent = nullptr);
    ~MainViewWidget();

protected:

    void initUi();

    void paintEvent(QPaintEvent *event);

public Q_SLOTS:
    void styleChangeSlot(const QString &style);

Q_SIGNALS:

    void directoryChangedSignal();

    void sendDirectoryPath();
private:
    QString m_curStyle;
    QColor m_backColor;
};

#endif // MAINVIEWWIDGET_H
