/*
 * Copyright (C) 2022, KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef SPLITBARFRAME_H
#define SPLITBARFRAME_H
#include <QPushButton>
#include <QHBoxLayout>
#include <QLabel>
#include <QPixmap>
#include <QSettings>
#include "style.h"
#include "ukuimenuinterface.h"
#include "rightclickmenu.h"
#include "utility.h"

class SplitBarFrame : public QWidget //全屏分隔栏
{
    Q_OBJECT
public:
    /**
     * @param classify为0时为分类按钮、1为应用按钮
     * @param module为0时为常用模块，1为字母模块、2为功能模块
     */
    SplitBarFrame(QWidget *parent, QString category, int width, int height, int module);
    ~SplitBarFrame();

private:
    QString m_category;
    int m_width;
    int m_height;
    int m_module;
    QLabel *m_textLabel = nullptr;
    QFrame *m_line = nullptr;

protected:
    void initAppBtn();
    void paintEvent(QPaintEvent *event);
};

#endif // SPLITBARFRAME
