/*
 * Copyright (C) 2022, KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#include "style.h"
#include "src/UtilityFunction/utility.h"
#include <QDebug>
#include "src/UtilityFunction/utility.h"
#include "src/UtilityFunction/utility.h"
#include <QApplication>

Style::Style()
{
}

int Style::m_primaryScreenX = 0;
int Style::m_primaryScreenY = 0;
int Style::m_panelPosition = 0;
//默认窗口
int Style::m_minw = 0;
int Style::m_minh = 0;
int Style::m_leftPageWidth = 0;
int Style::m_leftPageHeight = 0;
int Style::m_defaultQueryLineEditIconSize = 0;
/**
  * 全屏窗口
  */
//主窗口
int Style::m_availableScreenWidth = 0;
int Style::m_availableScreenHeight = 0;
//搜索栏
int Style::m_queryLineEditHeight = 0;
//左侧栏
int Style::m_leftWidWidth = 0;
int Style::m_leftMargin = 0;
int Style::m_leftBtnWidth = 0;
int Style::m_leftBtnHeight = 0;
int Style::m_leftLetterBtnHeight = 0;
int Style::m_leftLetterFontSize = 0;
int Style::m_leftIconSize = 0;
int Style::m_leftSpaceIconText = 0;
int Style::m_leftSpaceBetweenItem = 0;
//应用列表栏
int Style::m_applistWidWidth = 0;
int Style::m_applistAreaWidth = 0;
int Style::m_applistWidHeight = 0;
int Style::m_scrollBarHeight = 0;
int Style::m_appListIconSize = 0;
int Style::m_appListBigIconSize = 0;
int Style::m_appTextRectHeight = 0;
int Style::m_boundaryOffset = 0;
int Style::m_appListItemSizeWidth = 0;
int Style::m_tabletItemSizeWidthOther = 0;
int Style::m_tabletItemSizeWidthFirst = 0;
int Style::m_firsPageViewWidth = 0;
int Style::m_otherPageViewWidth = 0;
int Style::m_applistGridSizeWidth = 0;
int Style::m_appLeftSpace = 0;
int Style::m_appTopSpace = 0;
int Style::m_appSpaceBetweenIconText = 0;
int Style::m_firstPageSpace = 0;
int Style::m_otherPageSpace = 0;

//侧边栏primaryScreen
int Style::m_sideBarWidWidth = 0;

int Style::m_appLine = 0;
int Style::m_appColumn = 0;
int Style::m_appLineFirst = 0;
int Style::m_appColumnFirst = 0;
int Style::m_appPage = 1;
int Style::m_appNum = 0;
int Style::m_nowpagenum = 1;
int Style::m_appRows = 0;
bool Style::m_screenRotation = false;
int Style::m_appListItemSizeHeight = 270;
int Style::m_appListViewTopMargin = 0;
int Style::m_screenWidth = 0;
int Style::m_screenHeight = 0;
int Style::m_appListViewBottomMargin = 20;
int Style::m_timeWidgetTop = 81;
int Style::m_timeWidgetLeft = 112;
int Style::m_centerWindHeight = 0;

int Style::m_minIconSize = 0;
int Style::m_rightViewWidth = 0;
int Style::m_rightViewHeight = 0;

void Style::initWidStyle()
{
    if (!g_projectCodeName.contains("V10SP1-edu")) {
        QVariantList list = getScreenGeometryList();
        m_primaryScreenX = list.at(0).toInt();
        m_primaryScreenY = list.at(1).toInt();
        m_availableScreenWidth = list.at(2).toInt();
        m_availableScreenHeight = list.at(3).toInt();
        m_panelPosition = list.at(5).toInt();
        int len = 0;
        QString locale = QLocale::system().name();

        if (locale == "zh_CN") {
            len = 0;
        } else {
            len = 10;
        }

        if (m_availableScreenWidth == 800 && m_availableScreenHeight == 600) {
            m_minw = 320;
            m_minh = 500;
            m_leftPageWidth = 300;
            m_leftPageHeight = 517;
        } else {
            m_minw = 652;
            m_minh = 590;
            m_leftPageWidth = 300;
            m_leftPageHeight = 517;
        }

        if (m_availableScreenWidth >= 2000 && m_availableScreenWidth <= 4000) {
            m_leftMargin = 20;
            m_leftLetterFontSize = 14;
            m_leftSpaceBetweenItem = 15;
            m_appListIconSize = 96;
            m_appListItemSizeWidth = 168;
            m_applistGridSizeWidth = 240;
            m_appSpaceBetweenIconText = 20;
        } else if (m_availableScreenWidth >= 1920 && m_availableScreenWidth < 2000) {
            m_leftMargin = 20;
            m_leftLetterFontSize = 14;
            m_leftSpaceBetweenItem = 15;
            m_appListIconSize = 86;
            m_appListItemSizeWidth = 168;
            m_applistGridSizeWidth = 220;
            m_appSpaceBetweenIconText = 18;
        } else if (m_availableScreenWidth >= 1600 && m_availableScreenWidth < 1920) {
            m_leftMargin = 10;
            m_leftLetterFontSize = 11;
            m_leftSpaceBetweenItem = 10;
            m_appListIconSize = 86;
            m_appListItemSizeWidth = 150;
            m_applistGridSizeWidth = 180;
            m_appSpaceBetweenIconText = 14;
        } else if (m_availableScreenWidth >= 1366 && m_availableScreenWidth < 1600) {
            m_leftMargin = 10;
            m_leftLetterFontSize = 11;
            m_leftSpaceBetweenItem = 10;
            m_appListIconSize = 64;
            m_appListItemSizeWidth = 112;
            m_applistGridSizeWidth = 140;
            m_appSpaceBetweenIconText = 0;
        } else if (m_availableScreenWidth >= 1280 && m_availableScreenWidth < 1366) {
            m_leftMargin = 10;
            m_leftLetterFontSize = 11;
            m_leftSpaceBetweenItem = 10;
            m_appListIconSize = 64;
            m_appListItemSizeWidth = 112;
            m_applistGridSizeWidth = 142;
            m_appSpaceBetweenIconText = 14;
        } else if (m_availableScreenWidth >= 1152 && m_availableScreenWidth < 1280) {
            m_leftMargin = 10;
            m_leftLetterFontSize = 11;
            m_leftSpaceBetweenItem = 10;
            m_appListIconSize = 64;
            m_appListItemSizeWidth = 112;
            m_applistGridSizeWidth = 142;
            m_appSpaceBetweenIconText = 14;
        } else if (m_availableScreenWidth > 800 && m_availableScreenWidth < 1152) {
            m_leftMargin = 10;
            m_leftLetterFontSize = 11;
            m_leftSpaceBetweenItem = 10;
            m_appListIconSize = 64;
            m_appListItemSizeWidth = 112;
            m_applistGridSizeWidth = 141;
            m_appSpaceBetweenIconText = 14;
        } else {
            m_leftMargin = 10;
            m_leftLetterFontSize = 11;
            m_leftSpaceBetweenItem = 10;
            m_appListIconSize = 64;
            m_appListItemSizeWidth = 112;
            m_applistGridSizeWidth = 138;
            m_appSpaceBetweenIconText = 14;
        }

        m_leftBtnWidth = 68 + 5 * len;
        m_leftBtnHeight = 34;
        m_queryLineEditHeight = 30;
        m_leftLetterBtnHeight = 25;
        m_leftIconSize = 19;
        m_rightViewWidth = 324;
        m_rightViewHeight = 470;
        m_leftSpaceIconText = 14;
        m_appTextRectHeight = 30;
        m_minIconSize = 8;

        m_appTopSpace = (m_appListItemSizeWidth - m_appSpaceBetweenIconText - m_appListIconSize - m_appTextRectHeight) / 2;
        m_boundaryOffset = (m_applistGridSizeWidth - m_appListItemSizeWidth) + m_appTopSpace + 10;
        m_applistWidWidth = m_availableScreenWidth / 1.25;
        m_applistWidWidth = m_applistWidWidth - (m_applistWidWidth % m_applistGridSizeWidth) + 2;
        m_applistWidHeight = m_availableScreenHeight - 120;
        m_applistWidHeight = m_applistWidHeight - (m_applistWidHeight % m_applistGridSizeWidth);
        m_leftWidWidth = (m_availableScreenWidth - m_applistWidWidth) / 2 + 1;
        m_applistAreaWidth = m_applistWidWidth + 20;
        m_scrollBarHeight = 10;
    } else {
        m_screenWidth = QApplication::primaryScreen()->geometry().width();
        m_screenHeight = QApplication::primaryScreen()->geometry().height();
        myDebug() << "Winches" << qApp->desktop()->widthMM();
        myDebug() << "Hinches" << qApp->desktop()->heightMM();
        myDebug() << "ScreenWidth" << m_screenWidth;
        myDebug() << "ScreenHeight" << m_screenHeight;
        m_appColumn = 6;
        m_appLine = 4;
        m_appLineFirst = 4;
        m_appListViewTopMargin = 70;
        m_appListViewBottomMargin = m_appListViewTopMargin - 30;
        m_leftWidWidth = m_screenWidth * 0.3;
        m_firsPageViewWidth = m_screenWidth - m_leftWidWidth - 5;
        m_appColumnFirst = m_firsPageViewWidth / 220;
        m_otherPageViewWidth = m_screenWidth;
        m_tabletItemSizeWidthFirst = m_firsPageViewWidth / m_appColumnFirst;
        m_tabletItemSizeWidthOther = (m_screenWidth - 5) / m_appColumn;
        m_centerWindHeight =  m_screenHeight - m_appListViewBottomMargin - m_appListViewTopMargin;
        m_appListItemSizeHeight = m_centerWindHeight / m_appLine;
        m_appListIconSize = 96;
        m_appListBigIconSize = 108;
        m_appTopSpace = (m_appListItemSizeHeight - m_appListIconSize) / 2;
        m_appLeftSpace = (m_tabletItemSizeWidthFirst - m_appListIconSize) / 2;
        m_timeWidgetTop = (m_centerWindHeight - 870) / 2;
        m_timeWidgetLeft = (m_leftWidWidth - 400) / 2;
        m_firstPageSpace = m_appLeftSpace;
        m_otherPageSpace = (m_tabletItemSizeWidthOther - m_appListIconSize) / 2;
    }
}
